/* $Id: gamereplay.hpp,v 1.1 2004/07/22 08:08:54 chfreund Exp $ */

#ifndef _GAMEREPLAY_HPP_
#define _GAMEREPLAY_HPP_

#include <fstream>
#include <SDL.h>
class World;
class Random;
class Player;
class String;
struct EchoData;

class GameReplay {
	private:
		enum RecordType {
			ECHO = 0,
			PLAYER_ENTER,
			PLAYER_QUIT,
			CHAT_MESSAGE
		};
	
	private:
		std::ofstream m_out;

	public:
		GameReplay( const char* filename, World* world, Random* random );
		~GameReplay();
		void addEcho( const EchoData& echo );
		void addPlayerEnter( const Player& player );
		void addPlayerQuit( Uint8 playerIndex );
		void addChatMessage( const String& message );
};

#endif // _GAMEREPLAY_HPP_
