/* $Id: mine.hpp,v 1.3 2004/11/25 15:39:46 pohlt Exp $ */

#ifndef _MINE_HPP_
#define _MINE_HPP_

/**********************************************************/

#include "global.hpp"
#include "constants.hpp"
#include "collidableobject.hpp"
#include "audio.hpp"
#include "vector.hpp"

/**********************************************************/

class Mine : public CollidableObject {
	friend class WeaponMine;
	public:
		Mine();
		bool initialize( const Vector& pos, const Vector& vel,
		                 const Uint8 owner, const Sint32 deadTime,
		                 const Sint32 nShrapnels, const Sint32 damage );
		virtual Sint32 getID() const { return MINE; }
		virtual void update();
		virtual int applyDamage( const Particles::ParticleData& p );

		virtual void serialize( Uint8*& bufferPointer ) const;
		virtual void deserialize( Uint8*& bufferPointer );
		virtual Uint32 getSerializeBufferSize() const;

	protected:
		Uint8  m_owner;
		Sint32 m_deadTime;
		Sint32 m_jumpTimer;
		Sint32 m_nShrapnels;
		Sint32 m_damage;
		static Mix_Chunk *m_explodeSample,
		                 *m_bounceSample,
		                 *m_triggerSample,
		                 *m_damageSample;
};

/**********************************************************/

#endif /* _MINE_HPP_ */
