/* $Id: scoretable.hpp,v 1.5 2005/02/21 20:49:01 chfreund Exp $ */

#ifndef _SCORETABLE_HPP_
#define _SCORETABLE_HPP_

#include <vector>
#include "player.hpp"
#include "scorekeeper.hpp"
#include "widget.h"
#include "textlabel.h"

using namespace SDLwidgets;

class ScoreTable : public WidgetComposite {
	private:
		TextLabel* m_tableHeader[5];
		std::vector<TextLabel*> m_scoreLabels;
		
		struct TeamScore {
			Uint8 teamID;
			Sint32 nFrags, nKills, nDeaths, nDamage;
		};
		
		class CompareTeamByFrags {
			public:
				int operator()( TeamScore* const t1, TeamScore* const t2 ) const {
					return t1->nFrags > t2->nFrags;
				}
		};
		
		class ComparePlayerByFrags {
			public:
				int operator()( Player* const p1, Player* const p2 ) const {
					Scorekeeper* sk = Scorekeeper::getInstance();
					//return p1->getFrags() > p2->getFrags();
					return sk->getFragsForPlayer( p1->getPlayerID() ) >
					       sk->getFragsForPlayer( p2->getPlayerID() );
				}
		};

	public:
		ScoreTable();
		void updateScores( std::vector<Player*> players );
};

#endif // _SCORETABLE_HPP_
