/* $Id: weapon.cpp,v 1.4 2004/07/13 12:33:08 pohlt Exp $ */

#include "weapon.hpp"
#include "audio.hpp"
#include "avatar.hpp"

void Weapon::shoot( World* world, Avatar* avatar ) {
	if ( m_ammo > 0 && m_reloadTimer == 0 && reallyShoot( world, avatar ) ) {
		// play shot sample
		Audio::getInstance()->playSound( m_shotSample, avatar->getIntPositionX(),
		                                               avatar->getIntPositionY() );
				
		// decrease ammo
		m_ammo--;
		// if no ammo is left start recharging
		if ( m_ammo == 0 ) {
			m_chargeTimer = getChargeTime();
		}
		else {
			// set reload timer
			m_reloadTimer = getReloadTime();
		}
	}
}
