/* $Id: weapongrenade.hpp,v 1.6 2004/06/28 08:50:40 pohlt Exp $ */

#ifndef _WEAPONGRENADE_HPP_
#define _WEAPONGRENADE_HPP_

#include "weapon.hpp"
#include "grenade.hpp"
#include "audio.hpp"

class WeaponGrenade : public Weapon {
	public:
		WeaponGrenade() {
			rechargeNow();
			m_shotSample = Audio::getInstance()->loadSound( "sound/weapons/grenade/drop_pin.wav" );
			Grenade::m_explodeSample = Audio::getInstance()->loadSound( "sound/effects/explosion1.wav" );
			Grenade::m_bounceSample = Audio::getInstance()->loadSound( "sound/weapons/grenade/bounce.wav" );
			Grenade::m_damageSample = Audio::getInstance()->loadSound( "sound/effects/ricochet.wav" );
		}

		virtual bool reallyShoot( World* world, Avatar* avatar ) const ;
		
		virtual Uint32 getMaximumAmmo() const {
			return 2;
		}
		virtual Uint32 getReloadTime() const {
			return 40;
		}
		virtual Uint32 getChargeTime() const {
			return 100;
		}
};

#endif // _WEAPONGRENADE_HPP_
