/* $Id: weaponmine.hpp,v 1.3 2004/11/25 15:39:46 pohlt Exp $ */

#ifndef _WEAPONMINE_HPP_
#define _WEAPONMINE_HPP_

#include "weapon.hpp"
#include "mine.hpp"
#include "audio.hpp"

class WeaponMine : public Weapon {
	public:
		WeaponMine() {
			rechargeNow();
			m_shotSample = NULL; //Audio::getInstance()->loadSound( "sound/weapons/mine/drop_pin.wav" );
			Mine::m_explodeSample = Audio::getInstance()->loadSound( "sound/effects/explosion1.wav" );
			Mine::m_bounceSample  = Audio::getInstance()->loadSound( "sound/weapons/grenade/bounce.wav" );
			Mine::m_triggerSample = Audio::getInstance()->loadSound( "sound/weapons/mine/trigger.wav" );
			Mine::m_damageSample  = Audio::getInstance()->loadSound( "sound/effects/ricochet.wav" );
		}

		virtual bool reallyShoot( World* world, Avatar* avatar ) const ;
		
		virtual Uint32 getMaximumAmmo() const {
			return 1;
		}
		virtual Uint32 getReloadTime() const {
			return 1;
		}
		virtual Uint32 getChargeTime() const {
			return 200;
		}
};

#endif // _WEAPONMINE_HPP_
