/* $Id: weaponuzi.cpp,v 1.17 2005/04/08 13:16:04 pohlt Exp $ */

#include "weaponuzi.hpp"
#include "world.hpp"
#include "avatar.hpp"

bool WeaponUzi::reallyShoot( World* world, Avatar* avatar ) const {
	// place bullet particle
	const real power = 30.0 - 6.0 * globalRnd.getNormedReal();
	world->getParticles()->addParticle( Particles::ParticleData(
			avatar->placeBesideCollRect(),
			avatar->getRandomizedAimingVector( 2, power ) + avatar->getSpeed(),
			Particles::EXPL_EARTH | Particles::EXPL_OBJECT | Particles::DAMAGE | Particles::EXPL_GEN_SPARKS,
			0, avatar->getPlayer()->getPlayerID(), 100, 40, 0xffffff));

		// place bullet casing
		world->getParticles()->addParticle( Particles::ParticleData(
				Vector( avatar->getPositionX() +
				        (avatar->isFacingRight() ? 5 : -5),
				        avatar->getPositionY() + avatar->getWeaponPivotDY() ),
				Vector(  0.5*(0.5 - globalRnd.getNormedReal() ),
				        -0.7*(1.0 + globalRnd.getNormedReal() ) ) + avatar->getSpeed(),
				Particles::BOUNCE_EARTH | Particles::REDUNDANT, 0, 0, 75, 1, 0xaaaaaa ) );

		// apply recoil
		avatar->setSpeed( avatar->getSpeedX() - avatar->getAimingDX() * power / avatar->getMass(),
		                  avatar->getSpeedY() - avatar->getAimingDY() * power / avatar->getMass() );

	return true;
}
