/* $Id: wopwindow.cpp,v 1.4 2004/12/29 21:50:37 chfreund Exp $ */

#include "wopwindow.hpp"

#include <sstream>

#include "graphics.h"
#include "layout.h"
using namespace SDLwidgets;

#include "wopsettings.hpp"

WopWindow::WopWindow()
	: m_titleLabel( "tahomabd.ttf", 14, "" ), m_widget( 0 ) {
	// default colors
	m_titleColor.r = 0;
	m_titleColor.g = 0;
	m_titleColor.b = 0;
	m_titleBackgroundColor.r = 0;
	m_titleBackgroundColor.g = 0;
	m_titleBackgroundColor.b = 255;
	m_titleAlpha = 50;
	m_contentBackgroundColor.r = 0;
	m_contentBackgroundColor.g = 0;
	m_contentBackgroundColor.b = 255;
	m_contentAlpha = 50;
	
	m_content = new WidgetComposite( 0, 0 );
	m_content->setLayout( new VerticalLayout( m_content ) );	
	m_titleLabel.setColor( m_titleColor );
	
	std::ostringstream path;
	path << WopSettings::getInstance()->getData();
	path << "/images/gui/bg.png";
	m_background = new BackgroundWidget( m_content, path.str().c_str() );
	m_border = new Border3DWidget( m_background );
	WidgetProxy::setWidget( m_border );
}

WopWindow::WopWindow( Widget* widget, std::string title )
	: m_titleLabel( "tahomabd.ttf", 14, title ) {
	// default colors
	m_titleColor.r = 0;
	m_titleColor.g = 0;
	m_titleColor.b = 0;
	m_titleBackgroundColor.r = 0;
	m_titleBackgroundColor.g = 0;
	m_titleBackgroundColor.b = 255;
	m_titleAlpha = 50;
	m_contentBackgroundColor.r = 0;
	m_contentBackgroundColor.g = 0;
	m_contentBackgroundColor.b = 255;
	m_contentAlpha = 50;
	
	m_content = new WidgetComposite( 0, 0 );
	m_content->setLayout( new VerticalLayout( m_content ) );
	m_titleLabel.setColor( m_titleColor );
	setWidget( widget );
	
	std::ostringstream path;
	path << WopSettings::getInstance()->getData();
	path << "/images/gui/bg.png";
	m_background = new BackgroundWidget( m_content, path.str().c_str() );
	m_border = new Border3DWidget( m_background );
	WidgetProxy::setWidget( m_border );
}

WopWindow::~WopWindow() {
}

void WopWindow::setWidget( Widget* widget ) {
	m_widget = widget;
	m_content->removeAll();
	m_content->add( &m_titleLabel );
	m_content->add( m_widget );
}

void WopWindow::setTitle( std::string title ) {
	m_titleLabel.setText( title );
	m_content->removeAll();
	m_content->add( &m_titleLabel );
	if ( m_widget )	
		m_content->add( m_widget );
}
